__doc__ = """\
: IIGFS
: Sun Sep 24 03:12:37 MSK 2000
:  Andrey Orlov  (c) 2002
c: $Id: libIIGFS.py,v 1.76 2003/01/12 16:24:52 cray Exp $

:
        IIGFS /   
        
:        
           
        ,   . 
          ,    
         libIIGFS_mixin,  
              IIGFS.

            
             .

:
        GPL
        
   :
           

"""
__version__ = '$Revision: 1.76 $'[10:-1]
# $Source: /var/lib/cvs/IIGFS/zope/Products/MOFS/libIIGFS.py,v $

debug = 0

import urllib
import string
import cgi
import re
from marshal import loads,dumps
from zlib import decompress,compress
from base64 import encodestring,decodestring
from Globals import MessageDialog
import DateTime 
trivial_trancetable = string.maketrans('','')
from AccessControl.SecurityManagement import getSecurityManager

from marshal import loads
from zlib import decompress
from urllib import unquote

#compress = lambda x : x
#decompress = lambda x : x

CantUnpack = 'Can not unpack data'

Unauthorized = 'Unauthorized'

def percon( prms ) :
    """    ,    """
    d = {}
    for prm in prms :
        p = prm[0]

        if not d.has_key(p) :
            d[p] = [[],None]

            f = prm[1]
        d[p][0] = d[p][0] + list(filter(lambda x,f=d[p][0] : not x in f,f))

        try :
            r = prm[2]
            if d[p][1] is not None :
                d[p][1] = d[p][1] + list(filter(lambda x,r=d[p][1] : not x in r,r))
            else :
                d[p][1] = r
        except IndexError :
            pass

    prms = []
    for p in d.keys() :
        if d[p][1] is None :
            prms.append((p,tuple(d[p][0])))
        else :
            prms.append((p,tuple(d[p][0]),tuple(d[p][1])))
    return tuple(prms)

from DocumentTemplate import DT_Util
import ZPublisher.HTTPRequest

class crayDateTime (DateTime.DateTime) :

        """  DateTime   
          record .   
           /     
          -.

        __init__        -  DateTime.__init__  
                  record.      record
                     ;

        reinit          -   DateTime  
                 record;

        reinit_safe     -  ,    ;
        """

        positions = {
                'year':(0,int), 'yy':(0,int),
                'mm':(1,lambda x : max(min(int(x),12),1)), 'month':(1,lambda x : max(min(int(x),12),1)),
                'dd':(2,lambda x : max(min(int(x),31),1)), 
                'hour':(3,lambda x : max(min(int(x),24),0)), 'h_24':(3,lambda x : max(min(int(x),24),0)), 
                'minute':(4,lambda x : max(min(int(x),60),0)), 
                'second':(5,lambda x : max(min(float(x),62),0)),
        }

        def __init__(self,*args) :
                if len(args) == 1 and isinstance(args[0],ZPublisher.HTTPRequest.record) :
                        DateTime.DateTime.__init__(self)
                        self.reinit_safe(record=args[0])
                else :
                        apply(DateTime.DateTime.__init__,(self,)+args,{})
                        

        def reinit_safe(self,record=None) :
                try :
                        return self.reinit(record)
                except :
                        pass
                return self

        def reinit(self,record=None)  :
                if record :
                        t = list(self.parts())
        
                        for item in record.keys() :
                                s = record[item]
                                if s :
                                        t[self.positions[item][0]] = self.positions[item][1](s)
                        apply(DateTime.DateTime.__init__,[self]+t,{})
                return self

        def fuck_me_every_day(self) :
                return 'fuck!!!' 

DT_Util.TemplateDict.__dict__['crayDateTime'] =  crayDateTime

class libIIGFS_mixin :
    """  ,     Z-
           dtml.

    """

    def response_cache_headers(self,REQUEST=None,is_cached=None,interval=None) :
        """   , :

                REQUEST - ,     ;
                is_cached -  /  ,  
                           response_is_cached ;
                interval -    ,  
                 
                         response_cache_interval ;

                     "Allow view
                uncached pages",    
                .
        """

        if getSecurityManager().checkPermission('Allow view uncached pages', self) :
            is_cached = 0
        else :
            if is_cached is None :
                try :
                        is_cached = self.response_is_cached
                except AttributeError :
                        is_cached = 0

        if is_cached and interval is None :
                try :
                        interval = self.response_cache_interval
                except AttributeError :
                        interval = 900

        if REQUEST is None :
                REQUEST = self.REQUEST

        if is_cached :
                REQUEST.RESPONSE.setHeader('Expires', DateTime.DateTime(DateTime.DateTime().timeTime() + interval).toZone('GMT').rfc822())
                REQUEST.RESPONSE.setHeader('Last-Modified',DateTime.DateTime(DateTime.DateTime().timeTime() - interval).toZone('GMT').rfc822())
        else :
                REQUEST.RESPONSE.setHeader('Expires', DateTime.DateTime().toZone('GMT').rfc822())
#		REQUEST.RESPONSE.setHeader('Etag', "%f" % DateTime.DateTime().timeTime())
#                REQUEST.RESPONSE.setHeader('Last-Modified',DateTime.DateTime(DateTime.DateTime().timeTime()).toZone('GMT').rfc822())

        return 

    def request_setstart(self,seq,start_id='start_id',start='start',check=None) :
        """     start    
         start_id   , :

        seq -  ,   ;

        start_id -   ,  
        ;

        start -   ,     
        ;

            . """

        if self.REQUEST.has_key(start_id) :
            start_id = self.REQUEST[start_id] 
            for n in range(0,len(seq)) :
                if seq[n].getId() == start_id :
                        self.REQUEST[start] = n+1
                        break
        else :
            if check :
                raise 'NotFound', " %s  " % start_id
        return seq

    def request_remote_ip(self,REQUEST) :
        """  IP-  .  ,
              ip.

              allow_empty_ip, 
           ip   REQUEST['REMOTE_ADDR']
        """

        if REQUEST['REQUEST_METHOD'] == 'POST':
                for attr,val in filter(lambda x : len(x)==2,map(lambda x : string.split(x,'=',1),string.split(REQUEST['QUERY_STRING'],'&'))) :
                        if attr=='ip' :
                                return val
        else :
                if REQUEST.form.has_key('ip')  :
                        return REQUEST.form['ip']

        try :
                if self.allow_empty_ip :
                        return REQUEST['REMOTE_ADDR']
        except AttributeError :
                return REQUEST['REMOTE_ADDR']
        
        raise 'UnknownIP',' IP-        '

    def request_http_referer(self,REQUEST) :
        """  url,     .
                http_referer, 
             HTTP_REFERER """

        if REQUEST.form.has_key('http_referer') :
                return REQUEST.form['http_referer']
        elif REQUEST.has_key('HTTP_REFERER') :
                return REQUEST['HTTP_REFERER']
        return ''

    def request_host_referer(self,REQUEST) : 
        """  ,     .  
               http_referer,  
            HTTP_REFERER.   ,
          ."""
        
        ref = self.request_http_referer(self,REQUEST) 
        try :
                if ref :
                        return string.split(string.split(ref,'/')[2],':')[0]
        except IndexError :
                pass

        return ref 

    def request_filter_keys(self,REQUEST,exclude=(),include=None,use_include=None) :
        """     
        
        REQUEST - c,
        include -    None   use_include   0,  
                       ,
        exclude -      ,
        use_include -   0,   include  
                .  
        """


        if include is None or (use_include==0) :
            include = REQUEST.form.keys()
        else :
            if type(include) is type('') :
                include = (include,)
            include = map(lambda x : x.split(':')[0], include)
            include = filter(REQUEST.form.has_key,include)

        if type(exclude) is type('') :
            exclude = (exclude,)

        exclude = map(lambda x : x.split(':')[0], exclude)
        return filter( lambda x,e=exclude : not (x in e), include)


    def request_filter_hash(self,REQUEST,exclude=[],include=None,use_include=None) :
        """   ,  request_filter_keys 
            -> .   record 
            <>.<>.   . 
        request_filter_keys.  """

        d = {}
        for attr in self.request_filter_keys(REQUEST,exclude,include,use_include) :
                value = REQUEST.form[attr]
                if isinstance(value,ZPublisher.HTTPRequest.record) :
                        for a1,v1 in value.items() :
                                d['%s.%s:record' % (attr,a1)] = v1
                else :
                        d[attr] = value
        return d

    def request_filter_hidden(self,REQUEST,exclude=[],include=None,use_include=None) :
        """   ,  request_filter_keys 
            HIDDEN,  .
        request_filter_keys 
        """

        s = ''
        for a,v in self.request_filter_hash(REQUEST,exclude,include,use_include).items() :
            t = type(v)
            if  t is type(0) :
                s = s + '<input type=hidden name="%s:int" value="%i">' % (a,v)
            elif t is type([]) or t is type(()) :
                for vs in v :
                    s = s + '<input type=hidden name="%s:list" value="%s">' % (a,cgi.escape(str(vs),1))
            else :
                s = s + '<input type=hidden name="%s" value="%s">' % (a,cgi.escape(str(v),1))
        return s

    def request_filter_query(self,REQUEST,exclude=[],include=None,use_include=None) :
        """   query,    ,
         request_filter_keys
        """

        s = ''
        for a,v in self.request_filter_hash(REQUEST,exclude,include,use_include).items() :
            t = type(v)
            if  t is type(0) :
                s = s + '%s:int=%i&' % (a,v)
            elif t is type([]) or t is type(()) :
                for vs in v :
                    s = s + '%s:list=%s&' % (a,urllib.quote_plus(str(vs)))
            else :
                s = s + '%s=%s&' % (a,urllib.quote_plus(str(v)))

        return s

    def request_default(self,name='',default=None,fault=None) :
        """    name ,    
          name -      
        .   - ,  'default',
         ,  'fault',  None.
        """

        l = string.split(name,'.')

        val = self.REQUEST
        for item in l :
                if val.has_key(item) :
                        val = val[item]
                else :
                        break
        else :
                return val

        if not (default is None) :
            return default

        val = self
        for item in l :
                if hasattr(val,item) :
                        val = getattr(val,item)
                else :
                        break
        else :
                return val

        uname = string.join(l,'_')
        if hasattr(self,uname) :
                return getattr(self,uname)

        if not (fault is None) :
                return fault

        return None

    def request_pack_hash(self,**kw) :
        """    request_pack   """
        return self.request_pack(kw)

    def request_unpack_hash(self, query) :
        """    query  request_unpack. 
          - ,       form.
        """
        hash = self.request_unpack(query)
        if type(hash) == type({}) :
            for attr,value in hash.items() :
                self.REQUEST.form[attr] = value
                self.REQUEST[attr] = self.REQUEST.form[attr]
        return hash

    def request_pack(self,item) : 
        """   item,     . 
           - marshal + zip + base64 + ""
        base64.   
        """

        s = dumps(item)
        z = compress(s)

        if len(z) >= len(s) :
            v = 's' + s
        else :
            v = 'z' + z

#       print "(len(z),len(s)) = ",len(z),len(s)
        return string.translate(encodestring(v),string.maketrans('/+','-:') ,'\012====')

    def request_unpack(self,query) :
        """     query, 
          request_pack
        """

        l=len(query)
        try :
            v = decodestring(
                        string.translate(
                            query,string.maketrans('-:','/+')
                        )
                        + ('=' * ((l+3)/4*4-l))
                )
            if v[0] == 'z' :
                return loads(decompress(v[1:]))
            else :
                return loads(v[1:])
        except :
            raise CantUnpack

    def request_ishere(self,url=None,right_margin=None,left_margin=None) :
        """   ,     url
           , :

        url -   ,  absolute_url(1),    -
                    ,
        right_margin -      url,  
                 -   ,
        left_margin -       url,  
                 -   ,

         1   .
        """

        if url is None :
            url = self.absolute_url(1)

        ur = string.split(url,'/')
        if right_margin : ur = ur[0:-right_margin]
        if left_margin  : ur = ur[0: left_margin]

        vr = list(self.REQUEST.get('VirtualRootPhysicalPath',[''])[1:])
        qr = string.split(self.REQUEST.PATH_INFO,'/')[1:]
        if debug :
            print '------------------- request_ishere'
            print 'VR:',vr
            print 'UR,QR 1:',ur,qr

        if vr == ur[0:len(vr)] :
            ur = ur[len(vr):]

        if vr == qr[0:len(vr)] :
            qr = qr[len(vr):]

        if debug : print 'UR,QR 2:',ur,qr

        if qr[0:len(ur)] == ur :
            return 1

        return None

    def request_msg_append(self,key,msg) :
        #       
        # key -  
        # msg -  
        #      
        # request_msg_list
        if not self.REQUEST.has_key('msg_errors') :
            self.REQUEST['msg_errors'] = {}

        try :
                self.REQUEST['msg_errors'][key].append(msg)
        except KeyError :
            self.REQUEST['msg_errors'][key] = [msg]

    def request_msg_check(self,key=None) :
        #     ,   key
        #       request_msg_append
        #   key  ,    .
        #   -    None

        if key is None :
            return self.REQUEST.has_key('msg_errors')
        else :
            try :
                return self.REQUEST['msg_errors'].has_key(key)
            except KeyError :
                return None

    def request_msg_list(self,key=None) :
        #   ,   key 
        #      request_msg_append  
        # key  ,      .

        if key :
            try :
                return self.REQUEST['msg_errors'][key]
            except KeyError :
                return []
        else :
            res = []
            if self.REQUEST.has_key('msg_errors') :
                for key,value in self.REQUEST['msg_errors'].items() :
                    res.extend(value)
                return res

    def request_datetime_check(self,attr='date',msg='  ',date=None) :
        """   crayDateTime(),     
         record.   ,    
         .

        attr -   ,  ,

        msg -   ,

        date -    DateTime,

        """

        if date is None :
                d = crayDateTime()
        else :
                d = crayDateTime(date)

        try :
                d.reinit(self.REQUEST['date'])
        except KeyError :
                self.request_msg_append(attr,msg)

        return d
        
    def request_check(self,**kw) :
        """      
         .      
           .
        """

        for val,checks in kw.items() :
            if (len(checks) == 2) and (type(checks[0]) != type(())) and (type(checks[0]) != type([])) :
                checks = (checks,)
            for r,msg in checks :
                reg = re.compile(r[1:])
                if r[0]=='-' :
                    if reg.search(self.REQUEST[val]) : self.request_msg_append(val,msg)
                elif r[0]=='+' :
                    if not reg.search(self.REQUEST[val]) : self.request_msg_append(val,msg)
                else :
                    raise ValueError,"Invalid symbol %s in regexp of (%s,%s,%s): first symbol must be '-' or '+'" % (r[0],val,r,msg)
        return self.request_msg_check()


    def zsql_last_insert_id(self, query, **kw):
        """  ZSQL  query   kw   last_insert_id """

        dbc = getattr(query, query.connection_id)
        dbc = apply(dbc)
        kw['src__'] = 1
        src = apply(query, (), kw)
        dbc.query(src)
        return dbc.db.insert_id()
    
    def zsql_affected_rows(self, query, **kw):
        """  ZSQL  query   kw   affected_rows """

        dbc = getattr(query, query.connection_id)
        dbc = apply(dbc)
        kw['src__'] = 1
        src = apply(query, (), kw)
        dbc.query(src)
        return dbc.db.affected_rows()


    def zsql_method_scroll(self,method,key='start',size=10,exclude=[],include=None,REQUEST=None,**kw) :
        """    ZSQL ,   zsql_result_list. 
        
          ZSQL       (start & size).  .
         zsql_result_scroll."""

        if REQUEST is not None :
            for arg,val in REQUEST.form.items() :
                kw[arg] = val

        kw['start'] = max(0,int(self.request_default(key,1)) - 1)
        kw['size']  = int(size)+1
        return self.zsql_result_scroll(
            apply(method,(),kw),
            key,size,exclude,include)

    def zsql_result_scroll(self,l=None,key='start',size=10,exclude=[],include=None,r=None) :
        """     l  mysql ,
           :

        previous-sequence-start-number --    
              None;

        next-sequence-start-number --    
              None;

        previous-sequence-query --    ;

        previous-sequence-query --    ;

           - size,    
         - key,  exclude & include  
         request_filter*     
        -.

           .  
        """

        if not self.REQUEST.has_key(key) :
            start = 0
        else :
            start = max(int(self.REQUEST[key])-1,0)

        if (r is None) and (l is not None) :
            try :
                r = l.dictionaries()
            except AttributeError :
                r = l
        d = {}
        d['previous-sequence-start-number']       = None
        d['next-sequence-start-number']           = None
        d['previous-sequence-query']              = None
        d['next-sequence-query']                  = None
        d['previous-sequence-url']                = None
        d['next-sequence-url']                    = None

        qs = self.request_filter_query(self.REQUEST,exclude=[key]+list(exclude),include=include)
        if start > 0 :
            d['previous-sequence-start-number'] = max(start+1-size,1)
            d['previous-sequence-query'] = '%s%s=%u' % (qs,key,d['previous-sequence-start-number'])
            d['previous-sequence-url'] = self.REQUEST['URL1']+'?'+d['previous-sequence-query']
            
        if len(r) > 0 :
            if len(r) > size :
                d['next-sequence-start-number'] = start + 1 + size
                d['next-sequence-query'] = '%s%s=%u' % (qs,key,d['next-sequence-start-number'])
                d['next-sequence-url'] = self.REQUEST['URL1']+'?'+d['next-sequence-query']
                r = r[0:size]

            for a,v in d.items() :
                r[0][a] = v
                r[-1][a] = v

        return r

    marked_list = zsql_result_scroll
    marked_list_db = zsql_method_scroll

    def cookielist_unpack(self,prefix='fld') :
        #   ,      
        # fld.     
        # cookielist_edit

        if self.REQUEST.has_key(prefix + '_list') :
            try :
                return self.request_unpack(self.REQUEST[prefix + '_list'])
            except CantUnpack :
                pass
        return []
        

    def cookielist_edit(self,prefix='fld',add=[],lifeperiod=None, path='/') :
        """   ,    c  fld,
        :

        prefix -   ,   ,

        add -   ,

        lifeperiod -   ,    -  
         ,

        path -     (. RFC),

          :

        <PREFIX>_add -    ,  
                     add,

        <PREFIX>_delete -    ,  
                    <PREFIX>_id, 
                  .

        <PREFIX>_first -     , 
                     <PREFIX>_id,
                   .

        <PREFIX>_clean -   

               <PREFIX>_list  
         .
        """

        l = self.cookielist_unpack(prefix)
        if self.REQUEST.has_key(prefix + '_add') :
            if type(add) is not type([]) :
                l.extend([add])
            else :
                l.extend(add)

        elif self.REQUEST.has_key(prefix + '_delete') :
            try :
                di = map(lambda x: int(x), self.REQUEST[prefix + '_id'])
            except KeyError :
                self.request_msg_append(prefix + '_list', '      ')
                return l

            di.reverse()
            try :
                for item in di :
                    del(l[item])
            except IndexError:
                self.request_msg_append(prefix + '_list', '   ')
                return self.cookielist_unpack(prefix)
    
        elif self.REQUEST.has_key(prefix + '_first') :
            try :
                di = map(lambda x: int(x), self.REQUEST[prefix + '_id'])
            except KeyError :
                self.request_msg_append(prefix + '_list', '        ')
                return l
            
            try :
                n = 0
                for item in di :
                    l.insert(n,l[item])
                    n = n + 1
                    del(l[item+1])
            except IndexError :
                self.request_msg_append(prefix + '_list', '      ')
                return self.cookielist_unpack(prefix)
	elif self.REQUEST.has_key(prefix + '_clear') :
	    l = []
        else :
            return l
            
        self.cookielist_set(l,prefix,lifeperiod,path)
        return l

    def cookielist_set(self,l,prefix='fld',lifeperiod=None,path='/') :
        """       """
        cookie = self.request_pack(l)
        if debug : print ' ',len(cookie) 
        if len(cookie) > 1024 :
                self.request_msg_append(prefix + '_list', '   , ..  ')
                return self.request_unpack(self.REQUEST[prefix + '_list'])

        d = {}
        if lifeperiod :
                d['expires'] = (DateTime.DateTime()+lifeperiod).rfc822()
        if path :
		if path[0] != '/' :
		   path = '/' + path
                d['path'] = path

	#print 'path',path
        apply(self.REQUEST.RESPONSE.setCookie,(prefix + '_list',cookie),d)

        return l

    def propertyes_listobjects(self,tokens=[]) :
        #   ,    tokens  
        return [ (token,self.restrictedTraverse(token).title_and_id()) for token in tokens if self.restrictedTraverse(token,default="") ]

    def filter_empty_string(self,l=[]) :
        """         """

        return [ x for x in map(lambda x: string.strip(x), l) if x ]


    def pathValues(self,anchor='Main',types=None,skip=1) :
        #       , :
        #       anchor  -   ,    
        #               ,     ,   
        #               .
        #
        #       types   -   ,   , 
        #               None -   ,
        #
        #       skip    -  ,    ,
        #       

        ob = self.anchor_Object(anchor,default=self.getPhysicalRoot())
        anchor_path = ob.getPhysicalPath()
        vpath = []
        if skip :
                path = self.getPhysicalPath()[len(anchor_path):-skip]
        else :
                path = self.getPhysicalPath()[len(anchor_path):]

        if types is None or ob.meta_type in types :
                vpath.append(ob)

        for item in path :
                ob = getattr(ob,item)
                if types is None or ob.meta_type in types :
                        vpath.append(ob)
        return vpath
                
    def pathJoin(self,anchor='Main',types=None,skip=1,title='title_or_id',delim='/',format='<a href="%(url)s">%(title)s</a>') :
        #           , :
        #       
        # title - ,   ,
        #
        # delim -    ,
        #
        # format -   ,     url &
        #       title
        # anchor,types,skip -    
        #       path_Values

        return string.join(map(lambda x,f=format,t=title:  f % {'url' : x.absolute_url(), 'title' : getattr(x,t)()}, self.path_Values(anchor,types,skip)),delim)

    path_Join = pathJoin
    path_Values = pathValues

    def absoluteTraverse(self,path,default=None) :
        #  ,    
        #
        #       path    -   ,
        #       default -      .
        #
        ob = self.getPhysicalRoot()
        ob = ob.restrictedTraverse(path,default)
        if ob is not default and self.getPhysicalUrl(ob) == path :
                return ob
        return default

    def getPhysicalUrl(self,ob=None) :
        if ob is None :
                ob = self
        return string.join(ob.getPhysicalPath(),'/')

    def listValues(self,ids=[]) :
        #   ,   
        #  ,       
        # 

        return self._listValues(lambda x,self=self : getattr(self,x),ids)

    def listTraverse(self,ids=[]) :
        #   ,    
        # ,        

        return self._listValues(self.restrictedTraverse,ids)

 
    def _listValues(self,f,ids) :
        obs = []
        for id in filter(lambda x : x, ids) :
                try :
                        ob = f(id)
                except (Unauthorized,KeyError,AttributeError) :
                        continue
                if getSecurityManager().checkPermission('Access contents information', ob) :
                        obs.append((id,ob))
        return obs 

    _type_url_prefix = re.compile('^((http)|(ftp)|(mailto)|(int)|(javascript))[:/]*')
    _type_url_full = re.compile('^(((http)|(ftp)|(mailto))*.*\.)|(int|javascript).*$')

    def type_url_tunning(self,url='') :
        #"""   URL. URL   
        #http, ftp, mailto, int, javascript.     - 
        #  http:// """

        url = string.strip(url)
        if self._type_url_full.match(url) :
                if self._type_url_prefix.match(url) :
                        return url
                else :
                        return 'http://' + url

        return ''

    _type_email_check = re.compile('([A-Za-z_.0-9]+@([0-9A-Za-z_]+\.)+[0-9A-Za-z_]*)').search

    def type_email_tunning(self,email='') :
        #   email
        em = self.type_email_check(email)
        if em : 
                return em.group(0)
        return ''

    def type_email_check(self,email='') :
        return self._type_email_check(email)

    def type_datetime_tunning(self,datetime=None) :
        #   
        return crayDateTime(datetime)

    def get_reference(self,REQUEST) :
        """       """
        oblist = []
        if REQUEST.has_key('__cp') :
            type,refs = loads(decompress(unquote(REQUEST['__cp'])))
        
            for item in refs :
                try :
                        ob = self.restrictedTraverse(string.join(item,'/'))
                        oblist.append(ob)
                except (KeyError,'Unauthorized') :
                        pass

        return oblist           
